/* This is JavaScript code: it tells the web browser what to do when controls are clicked.
   Part of what web browsers can do today is to make network connections to other web servers;
   that’s what this particular example does. */
(() => {
  let showLoadingMessage = whichMessage => $(".loading." + whichMessage).removeClass("d-none");
  let hideLoadingMessage = whichMessage => $(".loading." + whichMessage).addClass("d-none");

  let jsonToString = json => JSON.stringify(json, null, 2);
  let xmlToString = xml => new XMLSerializer().serializeToString(xml);

  $("button.ensembl").click(() => {
    showLoadingMessage("ensembl");

    // Crib sheet: http://rest.ensembl.org/documentation/info/lookup
    $.getJSON("http://rest.ensembl.org/lookup/id/YFL039C?content-type=application/json;expand=1").done(response => {
      console.log("Ensembl", response);
      $("textarea.ensembl").val(jsonToString(response));
      hideLoadingMessage("ensembl");
    });
  });

  $("button.uniprot").click(() => {
    showLoadingMessage("uniprot");

    // Crib sheet: http://www.uniprot.org/help/api_retrieve_entries
    $.get("http://www.uniprot.org/uniprot/P60010.xml").done(response => {
      console.log("UniProt", response);
      $("textarea.uniprot").val(xmlToString(response));
      hideLoadingMessage("uniprot");
    });
  });
})();
